/***************************************************************************
                          fleet.cpp  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <fleet.h>

int Fleet::unique_id = 10;

Fleet::Fleet()
{
	id = unique_id++;
	dest.clear();
}

Fleet::Fleet(Point p)
{
	pos = p;
	strcpy(nameid, "fleet bleh");
	if(dest.empty()) setDest(pos);
	id = unique_id++;
	dest.clear();
}

void Fleet::addShip(Ship s)
{
	ships.push_back(s);
}

int Fleet::numDest()
{
	if(this == NULL) return 0;
	return dest.size();
}

int Fleet::setDest(Point d)
{
/* 	returns 0 on error
	otherwise, number of waypoints */
	if(dest.size() == 0) dest.push_back(pos);
	dest.push_back(d);
	/* if this is the first location, we need to set the speed */
	if(dest.size() == 2)
	{
		Point p = dest[0] - dest[1];
		float l = p.length();
//		printf("length: %f\n", l);
		if(l > 2.0 * SPEED_CONST) l = 2.0 * SPEED_CONST;
		speed = pow( (( SPEED_CONST - (l/2))/SPEED_CONST), 2.0);
		speed = 10.0;
	}
	return dest.size();
}
/*
int Fleet::loadCargo(int n, int t)
{
	cargo[t] += n;
	if(cargo[t] < 0){
		n -= cargo[t];
		cargo[t] = 0;
		return n;
		}
	if(cargoFree()<0){
		n += cargoFree();
		cargo[t] -= cargoFree();
		return n;
		}
	return n;
}
  */
int Fleet::getShipType(int a)
{
	return ships[a].getType();
}

int Fleet::cargoMax(){
	int cargomax=0;
        for(int x=0;x<(int)ships.size();x++)
			cargomax += ships[x].getCargoMax();
	cout << "max: " << cargomax << endl;
    return cargomax;
}

int Fleet::cargoUsed(){
	int cargoused = 0;
	for(int x=0;x<CARGO_NUM;x++)
		cargoused += cargo[x];
		cout << "used: " << cargoused << endl; 
	return cargoused;
	}

int Fleet::cargoFree(){
	int n = cargoMax() - cargoUsed();
	cout << "free: " << n << endl;
	return n;
}

void Fleet::clearDest()
{
	dest.clear();
}

Point Fleet::getPos(){
	return pos;
}

int Fleet::size(){
	return ships.size();
}

bool Fleet::isFleet(){
	return 1;
}

vector<Point> Fleet::getDest(){
	return dest;
}

Point Fleet::getDest(int i)
{
	assert(i < dest.size() );
	return dest[i];
}


int Fleet::getSpeed(){
	/* get the min speed of all the ships */
	int s = INT_MAX;
	for(int x=0;x<(signed int) ships.size();x++){
		if(ships[x].getSpeed() < s) s=ships[x].getSpeed();
	}
	return s;
}

int Fleet::move(){
//	printf("moving fleet %d\n", id);
	if(dest.size()==0) setDest(pos);//always need at least our current pos
  	if(dest.size()==1) return 0;

	// dest[0] == current location
	// dest[1] == next waypoint
	// we are going from p1 to p2

/* adding map offsets */
	Point p1 = dest[0] + 500;
	Point p2 = dest[1] + 500;
	speed = 10.0; /* tmp fix */
	//get the vector b/w the 2 points
	Point p = p1 - p2;
	// scale it down
	float n = p.length() - speed;
//    printf("speed for move: %f\n", speed);
	if(n>0)
	{
		/* haven't made it to the next waypoint */
		cout << "p.length: " << p.length() << endl;
		n = 1-(n / p.length());
		cout << "n: " << n << endl;
		p.x = (int)(n * p.x);
		p.y = (int)(n * p.y);
		p.z = (int)(n * p.z);
//		cout << "p scaled down: "; p.print(); cout << endl;
//		cout << "dest: "; dest[0].print(); cout  << endl;
		dest[0] = dest[0] + p;
//		cout << "dest: "; dest[0].print(); cout  << endl;
		pos=dest[0];
		return 0;
	}
	else
	{
		/* 	made it to the next waypoint, move all the waypoints up
			and recalculate the speed */
		for(int x=0;x<(int)dest.size()-1;x++)dest[x]=dest[x+1];
		dest.pop_back();
		Point p = dest[0] - dest[1];
		float l = p.length();
	/* the speed calc is broken... */
/*
		if(l > (2.0 * SPEED_CONST) ) l = 2.0 * SPEED_CONST;
		speed = pow( (( SPEED_CONST - (l/2))/SPEED_CONST), 2.0);
		printf("speed: %f\n", speed);
*/
		/*  the 2.0 will eventually be replaced by the race's speed constant
			as defined by their research */
		/* ((100-(x/2))/100)**2; */
	
		pos=dest[0];
		return 1;
		/* we made it, return success */
    }
	return 0;
}

bool Fleet::checkOwner(int c){
	cout << "fleet checking owner\n";
	return 1;
}

int Fleet::getRaw(char *buf)
{
	int offset = Platform::getRaw(buf);

	int size = ships.size();
	memcpy(buf+offset, &size, sizeof(size));
	offset += sizeof(size);
	for(int i=0;i<size;i++)
	{
		offset += ships[i].getRaw(buf+offset);
	}

	size = dest.size();
	memcpy(buf+offset, &size, sizeof(size));
	offset += sizeof(size);
	for(int i=0;i<size;i++)
	{
		offset += dest[i].getRaw(buf+offset);
	}

	memcpy(buf+offset, &speed, sizeof(speed));
	offset += sizeof(speed);

	return offset;
}

int Fleet::setRaw(char *buf)
{
	int offset = Platform::setRaw(buf);

	int size = 0;
	memcpy(&size, buf+offset, sizeof(size));
//	printf("adding %d ships\n", size);
	offset += sizeof(size);
	for(int i=0;i<size;i++)
	{
		Ship s;
		offset += s.setRaw(buf+offset);
		ships.push_back(s);
	}

	size = 0;
	memcpy(&size, buf+offset, sizeof(size));
//	printf("adding %d dest points\n", size);
	offset += sizeof(size);
	for(int i=0;i<size;i++)
	{
		Point p;
		offset += p.setRaw(buf+offset);
		dest.push_back(p);
	}

	memcpy(&speed, buf+offset, sizeof(speed));
	offset += sizeof(speed);

	return offset;
}

Ship *Fleet::getShip(int i)
{
	if( i >= ships.size() ) return NULL;
	return &(ships[i]);
}

int Fleet::getMaxSpeed()
{
	int i;
	int max_speed = INT_MAX;
	for(i = 0;i< (int)ships.size();i++)
	{
		if(ships[i].getSpeed() < max_speed) max_speed = ships[i].getSpeed();
	}
	return max_speed;
}
