/***************************************************************************
                          fleet.h  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef FLEET_H
#define FLEET_H

#include <math.h>

#include <ship.h>
#include <point.h>
#include <unit_def.h>
#include <platform.h>

#define SPEED_CONST 400

class Fleet : public Platform{
public:
	Fleet();
	Fleet(Point p);

	void addShip(Ship s);
	void clearDest();

	bool isFleet();
	bool checkOwner(int c);
	int move();
	int setDest(Point d);
	int numDest();
	int getShipType(int a);
	int setId(int newid);
	int size();
	int cargoFree();
	int getSpeed();
	int getRaw(char *buf);
	int setRaw(char *buf);
	Ship * getShip(int i);
	vector<Point> getDest();
	Point getDest(int);
	Point getPos();

  /** returns max speed of fleet, ie speed of
the slowest ship in the fleet */
	int getMaxSpeed();
	
private:	
	static int unique_id; /* fleet id */

	int cargoUsed();
	int cargoMax();

	vector<Ship> ships;
	vector<Point> dest;
	time_t last_updated; /* time last updated */
	/* Platform::pos is the current position */
	float speed;
};


#endif
