/***************************************************************************
                          foundation.cpp  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <foundation.h>
#include <unistd.h>
#include <fstream.h>

Foundation::Foundation(){
/* we don't want people to see the planets before a game starts */
	for(int i = 0;i<PLANET_NUM;i++)
	{
		planet[i]->pos.x = 1000;
		planet[i]->pos.y = 1000;
		planet[i]->pos.z = 1000;
		planet[i]->setId( i );
	}

	ne.bindsocket(0);
	server_addr.sin_family = AF_INET;
	server_addr.sin_port = htons(5050);
	server_addr.sin_addr.s_addr = 0;
	SolarSystem::loadcosts();

/* should replace this with a callback!
	SolarSystem only uses it to add ships when production is finished */
	cout << "foundation initted\n\n";
	started = 0;
}

Foundation::~Foundation(){
}

void Foundation::start(){
	while(true){
/*		for(int x=0;x<PLANET_NUM;x++)
		if(planet[x].owner == OWNER){ 
		//	if( planet[x].produce() ) updateFleet();
			planet[x].produce(); 
			updateFleet();
			planet[x].grow(); 
			}
		shipdata.moveFleet();
		updateFleet();
	//	cout << "start\n";
		usleep(1000000);

	updateFleet();
*/
	net_wait();
	}
	return;
}

void Foundation::game_loop()
{
	while(!started) sleep(1); /* kinda ugly... */
	while(true)
	{
		cout << "move fleets:\n";
		moveFleet();
		
		doUIrequest();
		sleep(1);
	}
	return;
}

void Foundation::setBuildItem(int p, int g, int t, int q){
	struct production_request st_prod_req;
	st_prod_req.planet = p;	
	st_prod_req.group = g;
	st_prod_req.type = t;
	st_prod_req.quantity= q;
	ne.sendpacket(server_addr, PLANET_UPDATE, PRODUCTION_REQUEST,
		(char *)&st_prod_req, sizeof(st_prod_req));
}

/*
void Foundation::addShip(int t, Point p){
	cout << "adding ship in foundation\n";

	shipdata.addShip(t,p,player_id);
}
*/

void Foundation::setServerAddr(char *addr)
{
	printf("setting server address: %s\n", addr);
	struct hostent *hostname;
//	memset(hostname, 0, sizeof(hostname));
	if(!(hostname = gethostbyname(addr)))
	{
		tell_player("unknown server address");
		return;
	}
	memcpy((char *)&server_addr.sin_addr.s_addr, hostname->h_addr, hostname->h_length);
}

void Foundation::send_command(char *c)
{
	int offset=0;
	printf("sending command: %s\n", c);
	if(c[0] == '/')
	{	/* it's a command */
		offset++;	/* discard '/' */
		if(!strncmp(c+offset, "server", strlen("server")) )
		{
			setServerAddr(c+strlen("server  "));
			struct game_join st_game_join;
			strcpy(st_game_join.player_name, "MyName"); /* must change later.... */
			ne.sendpacket(server_addr, GAME_UPDATE, GAME_JOIN,
				(char *)&st_game_join, sizeof(st_game_join) );
			return;
		}
		else if(!strncmp(c+offset, "start", strlen("start")) )
		{
			int dummy;
			ne.sendpacket(server_addr, GAME_UPDATE, GAME_START,
				(char *)&dummy, sizeof(dummy) );
			return;
		}
		else if(!strncmp(c+offset, "quit", strlen("quit")) )
		{
			exit(0);
		}
	}
	else
	{	/* it's a general chat message */

		/* if the server addr isn't set yet, don't send */
		if(server_addr.sin_addr.s_addr == 0) return;
		struct chat_msg st_chat_msg;
		st_chat_msg.from_player = 0;
		st_chat_msg.to_player = -1;
		strcpy(st_chat_msg.msg, c);
		ne.sendpacket(server_addr, GAME_UPDATE, CHAT_MSG, (char *) &st_chat_msg,
			sizeof(st_chat_msg));
	}
}

void Foundation::handle_chat_msg(char *buf, int len)
{
	struct chat_msg st_chat_msg;
	memcpy(&st_chat_msg, buf, len);
	char * new_msg = (char *)malloc(strlen(st_chat_msg.msg));
	strcpy(new_msg, st_chat_msg.msg);
	tell_player(new_msg);
}

void Foundation::tell_player(char *)
{
	printf("Should not be called!!\n\n");
}

void Foundation::handle_game_start(sockaddr_in addr, char *buf, int len)
{
	game_start *st_game_start = (game_start *)buf;
	printf("my starting location: %d\n", st_game_start->my_start_planet);
	show_planet(st_game_start->my_start_planet);
	started = 1;
}

void Foundation::handle_planet_info(char *buf, int len)
{
	int i = 0;
	memcpy(&i, buf, sizeof(i));
	printf("\n");
	planet[i]->setRaw(buf+sizeof(i));
}

/** tells the UI to show the player this planet
meant to be implemented in the UI */
void Foundation::show_planet(int planet_id)
{
}

/** let's the UI request info it needs each turn */
void Foundation::doUIrequest()
{
}

/** requests update planet cargo info from
server */
void Foundation::requestPlanetCargoUpdate(int planet_id)
{
	ne.sendpacket(server_addr, PLANET_UPDATE, PLANET_UPDATE_PART,
		(char *)&planet_id, sizeof(planet_id));
}
/**  */
void Foundation::handle_planet_part(sockaddr_in addr, char *buf, int len)
{
	struct update_part st_planet_part;
	int planet_id = 0;
/* copy the memory into a simpler structure */
	memcpy(&st_planet_part, buf, len);

	planet_id = st_planet_part.planet;

//	printf("updating cargo for planet %d\n", planet_id);

	/* now copy cargo info to planet */
	memcpy(planet[planet_id]->cargo, st_planet_part.cargo,
		sizeof(int)*CARGO_NUM);

	/* now copy building info to planet */
	memcpy(planet[planet_id]->building, st_planet_part.building,
		sizeof(bool)*BUILDING_NUM);

	/* now to make sure the queue does not contain completed items
		if an error occurs, request a full update
		note: full update not yet implemented */
	planet[planet_id]->setFrontId( st_planet_part.current_item );
	planet[planet_id]->setProgress( st_planet_part.progress );
}

void Foundation::handle_prod_request(sockaddr_in addr, char *buf, int len)
{
	struct production_request st_prod;
	memcpy(&st_prod, buf, sizeof(st_prod));
	planet[ st_prod.planet ]->setBuildItem(st_prod.group, st_prod.type);
}

void Foundation::handle_fleet_add(sockaddr_in addr, char *buf)
{
	Fleet *f = new Fleet();
	f->setRaw(buf);
	printf("adding new fleet with owner of %d\n", f->owner);
	addFleet(f);
}

void Foundation::handle_add_waypoint(sockaddr_in addr, char *buf, int len)
{
	struct fleet_waypoint st_fw;
	memcpy(&st_fw, buf, sizeof(fleet_waypoint) );

	Fleet *f;
	if( (f = getFleet(st_fw.fleet_id) ) != NULL)
	{
		f->setDest( planet[st_fw.waypoints[0] ]->getPos() );
	}
	else
	{
    /* 	we have no information on this fleet, so we should request a full
		update */
	}
}


int Foundation::add_waypoint(Fleet *f, int p)
{
/* if we added the waypoint to the fleet, we let the server know */
	int i = 0;
	if( FoundationCore::add_waypoint(f, p) )
	{
		struct fleet_waypoint st_fw;
		st_fw.fleet_id = f->getId();
		memset(st_fw.waypoints, -2, MAX_WAYPOINTS);

		st_fw.waypoints[0] = p;
		ne.sendpacket(server_addr, FLEET_UPDATE, FLEET_ADD_WAYPOINT,
			(char *)&st_fw, sizeof(struct fleet_waypoint) );
	}
}

void Foundation::sendTransferRequest(Platform *dest, Platform *source,
					int *amount)
{
	struct fleet_transfer_cargo cargo_request;
	cargo_request.dest = dest->getId();
	cargo_request.source = source->getId();
	cargo_request.isfleet = dest->isFleet();
	memcpy(cargo_request.cargo, amount, sizeof(int) * CARGO_NUM);
	ne.sendpacket(server_addr, FLEET_UPDATE, FLEET_TRANSFER_CARGO,
		(char *)&cargo_request, sizeof(struct fleet_transfer_cargo) );
}

void Foundation::moveFleet()
{
/* 	we want a seperated move for the client and server
	the client just moves the ships, the server must also
	update clients: if a fleet reaches a waypoint, the
	next waypoint must be sent to foreign players (not
	owner of fleet)
*/
//	printf("moving all fleets...\n");
	for(int x=0;x<(int)fleet.size();x++)
		fleet[x]->move();
}

