/***************************************************************************
                          foundation.h  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// this is the actual game object
// which the UI will interact w/

#ifndef CONFLICT_H
#define CONFLICT_H

#include <ship.h>
#include <shipInfo.h>
#include <system.h>
#include <vector>
#include <unit_def.h>
#include <fleet.h>
#include <sys/socket.h>
#include <netinet/ip.h>
#include <netdb.h>

#include <foundationcore.h>
#include <netengine.h>



class Foundation : public FoundationCore
{
public:
	Foundation();
	virtual ~Foundation();
	void start();
        /* fleet a, fleet b, value, type */
	void xfer(Platform *a, Platform *b, int amount, int cargo);
	virtual void setBuildItem(int p, int g, int t, int q);
	void addShip(int t, Point pos);
		/* sends a text message to the player via the UI */
	virtual void tell_player(char *);
	void game_loop(); 	/* main loop once game is started */
	void sendTransferRequest(Platform *dest, Platform *source, int *amount);
private:
	sockaddr_in server_addr; /* remote address */

	void setServerAddr(char *addr_name);
/*	network client routines */
	void handle_chat_msg(char *buf, int len);
	void handle_game_start(sockaddr_in addr, char *buf, int len);
	void handle_planet_info(char *buf, int len);
	void handle_prod_request(sockaddr_in addr, char *buf, int len);
	void handle_planet_part(sockaddr_in addr, char *buf, int len);
	void handle_fleet_add(sockaddr_in addr, char *buf);
	void handle_add_waypoint(sockaddr_in addr, char *buf, int len);
protected:
/* 	I _should_ make all the member variables private and not allow
	the GUI client to interact directly at all.  That would be much
	cleaner and is on the imaginary TODO list */
	void send_command(char *command);
    int add_waypoint(Fleet *f, int p);
	void 			moveFleet();
/**	tells the UI to show the player this planet
	meant to be implemented in the UI */
  virtual void show_planet(int planet_id);;

/** requests update planet cargo info from
	server */
	void requestPlanetCargoUpdate(int planet_id);

/** let's the UI request info it needs each turn */
	virtual void doUIrequest();
	int player_id;	/* my player id */
};


#endif
