/***************************************************************************
                          StarMap.h  -  description
                             -------------------
    begin                : Tue Jan 25 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef STARMAP_H
#define STARMAP_H

#include <point.h>
#include <GL/gl.h>
#include <vector>
#include <queue>
#include <plib/pu.h>
#include <sigc++/signal_system.h>
#include <unit_def.h>
#include <system.h>

using namespace std;
using namespace SigC;

class StarMap : puObject {
	
	public:
		StarMap(int a, int b, int c, int d);

		void setPlanet(vector<SolarSystem *> *p);
		void setFleet(vector<Fleet *> *f);
		void setStar(int);
		void init();
		void updateGL();
		void draw(int a, int b);
		int checkHit( int button, int updown, int x, int y);
		int getCurrentPlanet();
		int checkKey(int key, int updown);
		Signal1<void,int> planet_clicked;
		Signal1<void,int> fleet_clicked;
	private:
/* for mouse click events */
		void findPlanet(int mx, int my);
		void findFleet(int mx, int my);
		int findPlatform(vector<Platform *> *platform, int mx, int my);
		void makeOwner();
		int makeStar();
		void makeFleet();
		void makeSelect();
		Point draw_point(Point p, int pic);
		void paintGL();
		void setupView();

		int starPic[16];
		int ownerPic[16];
		int selected, fleet_pic;
		float coef[16];
		int star_selected, fleet_selected;
		vector<Fleet *> *fleet;
		vector<SolarSystem *> *planet;

		int current_planet;
		int mx, my;
		int rotX, rotY;
		int Xdelta, Ydelta;
		bool down[3];
		bool draw_plane;
};

#endif
