/***************************************************************************
                          commandline.cpp  -  description
                             -------------------
    begin                : Wed May 10 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "commandline.h"

CommandLine::CommandLine(int a, int b, int c, int d) : puInput(a, b, c, d)
{
	setColourScheme ( 0.35, 0.4, 0.51, 1.0) ;
	fntTexFont *tim = new fntTexFont ;
    tim -> load ( "courier-bold.txf" ) ;
	puFont font ( tim, 12 ) ;
	setLegendFont(font);
}


void CommandLine::draw(int a, int b)
{
	abox . draw ( a, b, PUSTYLE_SMALL_BEVELLED, colour, FALSE ) ;
	glColor4f(1.0,1.0,1.0,1.0);

	int xx = puGetStringWidth( legendFont, "9");
	char *val = (char *)malloc(PUSTRING_MAX);
	getValue(val);
	int string_size = puGetStringWidth( legendFont, val);

	if( string_size > (abox.max[0] - abox.min[0]))
	{
		val += (int)(( string_size - (abox.max[0] - abox.min[0]))/xx);
	}
	glTranslatef(0.0,0.0,0.1);
	puDrawString( legendFont, val,
		a + abox.min[0] + xx,
		b + abox.min[1] + (int)(10 * size_mult));
	int str_height = puGetStringHeight(legendFont);
	int i = 0;
	while( ((i * (str_height+4)) < (abox.max[1] - 20))
		&& i < (signed int)history.size())
	{
		puDrawString(legendFont, history[i],
			a + abox.min[0] + xx,
			i * (str_height + 4));
		i++;
	}
	glTranslatef(0.0,0.0,-0.1);
}



void CommandLine::input_cb(puObject *cb)
{	
}

int CommandLine::checkKey(int key, int updown )
{
	if(key == 13) /* newline */
	{
		char *val = (char *)malloc(PUSTRING_MAX);
		getValue(val);
		command_entered(val);
		setValue("");
	}
	if(key == 't' && !isAcceptingInput())
	{
        doHit(PU_LEFT_BUTTON, 1, abox.min[0]+1, abox.min[0]+1);
		printf("setting active\n");
		return 0;
	}
	return puInput::checkKey(key, updown);
}


CommandLine::~CommandLine(){
}

void CommandLine::tell_player(char *msg)
{
	printf("adding msg... %d start:%s:end\n", history.size(), msg);
	history.push_back(msg);
}
