/***************************************************************************
                          fleetview.h  -  description
                             -------------------
    begin                : Tue May 2 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FLEETVIEW_H
#define FLEETVIEW_H
#include <point.h>
#include <GL/gl.h>
#include <vector>
#include <queue>
#include <plib/pu.h>
#include <unit_def.h>
#include <system.h>

#include <sigc++/signal_system.h>

#include <system.h>
#include <fleet.h>
#include "userview.h"
#include "prodchoice.h"
#include "image.h"
#include "cargotransfer.h"

#define CARGO_TRANSFER 4

/*  different possible commands on a fleet
	order must match command_pics.txt!
	not the nicest
	-1 means no command is selected
	NEXT_FLEET 	- go to next fleet
	PREV_FLEET 	- go to previous fleet	
	ADD_WAYPOINT- add a waypoint for this fleet
	ADD_PATH	- add a series of waypoints for this fleet
	TRANS_CARGO	- transfer cargo/ships for this fleet
	others:
	MERGE_FLEET	- merge two fleets
	NEW_FLEET	- make a new fleet
*/

#define NEXT_FLEET 0
#define PREV_FLEET 1
#define ADD_WAYPOINT 2
#define ADD_PATH 3
#define TRANS_CARGO 4


using namespace std;
using namespace SigC;

/**Widget that displays info about the current selected
fleet.
  *@author Blake Friesen
  */

class FleetView : public UserView{
public: 
    FleetView(int a, int b, int c, int d);
    void draw(int a, int b);
    int checkHit( int button, int updown, int x, int y);
	int get_command_state();
	void set_fleet(Fleet *);
	Fleet *get_fleet();

    Signal3< void, Platform *,Platform *,int *> cargoRequest;
    Signal1< vector<Platform *>,Point> getPlatforms;
private:
	void setNextCargoDest();
	void setNextCargoSource();
/*	void getCargoLoc(float *x, float *y, int i); */
	void makeFleetLabels();		/*setup fleet_name, fleet_loc */
	void commandClicked(int);

  /** Updates the ships shown
 */
	void update_shiplist();

	puText		*fleet_name, *fleet_loc;
	ProdChoice	*cargoChoice, *shipChoice, *commandChoice;
	CargoTransfer *cargoTrans;
	Fleet *fleet; /* current fleet */
	Platform *dest;

};

#endif
