/***************************************************************************
                          foundationgl.h  -  description
                             -------------------
    begin                : Tue Jan 25 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFLICTGL_H
#define CONFLICTGL_H


#include <foundation.h>

#include "StarMap.h"
#include "planetview.h"
#include "fleetview.h"
#include "commandline.h"

/**
  *@author Blake Friesen
  */
using namespace std;
using namespace SigC;

class FoundationGL : public Foundation, public Object  {
public: 
	FoundationGL(int argc, char **argv);
	~FoundationGL();
	void display();
	void setbuilditem(int group, int type, int quantity);
	void tell_player(char *msg);
private:
	StarMap *starmap;
	PlanetView *planetview;
	FleetView *fleetview;
	CommandLine *commandline;
	void planet_clicked(int);
	void fleet_clicked(int);
	void command_entered(char *);
  /** extended from Foundation class
shows player a specific planet even
if they don't select it, meant for network
 or other game events  */
  void show_planet(int planet_id);
  /**  */
  void doUIrequest();
	int last_update, frames;
};

typedef vector<Platform *>(FoundationGL::*getPlatformByPos)(Point);
typedef void(FoundationGL::*cargoRequestType)(Platform *,Platform *,int *);

#endif
