/***************************************************************************
                          prodchoice.cpp  -  description
                             -------------------
    begin                : Sat May 6 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "prodchoice.h"

ProdChoice::ProdChoice(int a, int b, int c, int d) : puObject(a, b, c, d)
{
	selected = glList = -1;
	selected_img = ImageLoad("images/selected_cargo.rgb");
}

void ProdChoice:: draw(int dx, int dy)
{
	if(!visible) return;
	if(glList == -1)
	{
		glList = makeList(dx, dy);
	}
	glCallList(glList);
}

int ProdChoice::makeList(int dx, int dy)
{
//	printf("new list for prodchoice\n");
//	printf("tex size: %d\n", tex.size());
	int list = glGenLists( 1 );
	glNewList(list, GL_COMPILE);
	glEnable(GL_DEPTH_TEST);
	int tempStyle;
	if ( parent && ( ( parent->getType() & PUCLASS_POPUPMENU ) ||
                   ( parent->getType() & PUCLASS_MENUBAR   ) ) )
    	tempStyle =  ( getValue() ^ highlighted ) ? PUSTYLE_SMALL_SHADED : style ;
	else
	    tempStyle =  ( getValue() ^ highlighted ) ? -style : style ;
	abox . draw ( dx, dy, tempStyle, colour, isReturnDefault() ) ;
	glDisable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
//	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
	if(tex.size())
	{
//	printf("still making new list for prodchoice\n");
	glPixelZoom( size_mult/6, size_mult/6);
	for(int i=0;i<(signed int)display_list.size();i++)
	{

		float image_x;// = (x_divider*(i % width))+4*size_mult;
		float image_y;// = box_height-(14+(12/width)*(i-(i%width)))*size_mult;
		getPosition(&image_x, &image_y, i);
//		printf("imagey, min, max: %f, %d, %d\n", image_y, abox.min[1], abox.max[1]);
		if(image_y > 0)
		{
/* I really should clean this up a bit.... */
		glDisable(GL_TEXTURE_2D);
		glBegin(GL_TRIANGLES);
		glColor3ub(55, 140, 200);
		glVertex3f(dx+abox.min[0]+image_x-1, dy+abox.min[1]+image_y-1, 0.0);
		glVertex3f(dx+abox.min[0]+image_x-1, dy+abox.min[1]+image_y+10.0*size_mult+1, 0.0);
		glVertex3f(dx+abox.min[0]+image_x+10.0*size_mult+1, dy+abox.min[1]+image_y+10.0*size_mult+1, 0.0);
		glColor3ub(25, 40, 60);
		glVertex3f(dx+abox.min[0]+image_x+10.0*size_mult+1, dy+abox.min[1]+image_y+10.0*size_mult+1, 0.0);
		glVertex3f(dx+abox.min[0]+image_x+10.0*size_mult+1, dy+abox.min[1]+image_y-1, 0.0);
		glVertex3f(dx+abox.min[0]+image_x-1, dy+abox.min[1]+image_y-1, 0.0);
		glEnd();
		glColor3ub(255, 255, 255);
		if(selected == i) glColor3ub(5, 255, 5);
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, tex[ display_list[i] ]);
		glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(dx+abox.min[0]+image_x, dy+abox.min[1]+image_y, 0.0);
		glTexCoord2f(0.0, 1.0); glVertex3f(dx+abox.min[0]+image_x, dy+abox.min[1]+image_y+10.0*size_mult, 0.0);
		glTexCoord2f(1.0, 1.0); glVertex3f(dx+abox.min[0]+image_x+10.0*size_mult, dy+abox.min[1]+image_y+10.0*size_mult, 0.0);
		glTexCoord2f(1.0, 0.0); glVertex3f(dx+abox.min[0]+image_x+10.0*size_mult, dy+abox.min[1]+image_y, 0.0);
		
		glEnd();
		} /* end if */
	   	}	/* end for loop */
	}	/* end if */
	glDisable(GL_TEXTURE_2D);
    glEndList();
	return list;
}

void ProdChoice::setTexList(vector<GLuint> list)
{
	if(glList == -1) glDeleteLists(glList, 1);
	glList = -1;
	tex = list;
//	printf("new tex size: %d\n", tex.size());
}

void ProdChoice::addTexList(vector<GLuint> list)
{
	if(glList == -1) glDeleteLists(glList, 1);
	glList = -1;
	for(int i=0;i < (signed int)list.size();i++)
	{
		tex.push_back(list[i]);
	}
//	printf("new tex size: %d\n", tex.size());
}


void ProdChoice::setDisplayList(vector<int> list)
{
	if (list == display_list) return;
	if(glList == -1) glDeleteLists(glList, 1);
	glList = -1;
	display_list = list;
//	printf("display list update, size: %d\n", list.size());
}

int ProdChoice::get_selected()
{
	return selected;
}

void ProdChoice::set_selected(int s)
{
	selected = s;
   	if(glList == -1) glDeleteLists(glList, 1);
	glList = -1;
}


void ProdChoice::getPosition(float *x, float *y, int i)
{
	int box_width = abox.max[0] - abox.min[0];
	int box_height = abox.max[1] - abox.min[1];
	float x_divider = (float)(box_width-5) / (float)width;
	*x = (x_divider*(i % width))+4*size_mult;
	*y = box_height-(14+(12/width)*(i-(i%width)))*size_mult;
}

int ProdChoice::checkHit( int button, int updown, int x, int y)
{
//	printf("prodchoice checkHit called: button: %d, status: %d, x: %d, y: %d\n", button, updown, x, y);
	if( !((x > abox.min[0]) && (x < abox.max[0]) &&
			(y > abox.min[1]) && (y < abox.max[1])) )
	{
		return 0;
	}
	if(updown) return 0;
	x -= abox.min[0];
	y -= abox.min[1];
	for(int i=0;i<(signed int)display_list.size();i++)
	{
		float image_x;// = (x_divider*(i % width))+4*size_mult;
		float image_y;// = box_height-(14+(12/width)*(i-(i%width)))*size_mult;
		getPosition(&image_x, &image_y, i);
		if( (x > image_x) && (x < image_x+16.0*size_mult) && (y > image_y) && (y < image_y+16.0*size_mult))
		{
/*			selected = i; */
			image_clicked( display_list[i] );
//			printf("selected hit!! %d\n", i);
/*			glList = -1; */
		}
	}
	return 0;
}
