/***************************************************************************
                          texlist.h  -  description
                             -------------------
    begin                : Tue Jul 25 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TEXLIST_H
#define TEXLIST_H

#include <stdio.h>
#include <vector>
#include <GL/gl.h>

#include "texobject.h"

/**loads and caches textures to save texture mem
  *@author Blake Friesen
  */

class TexList {
public: 
	TexList();
	~TexList();
  /** loads an RGB file fname to use as a texture.  Returns
	 the texture. */
	static GLuint load_texture(char *fname);
	static void free_tex(char *fname);
	static void free_tex(int tex_id);
private:
	static vector<TexObject *> tex_list;	

};

#endif
