/***************************************************************************
                          texobject.cpp  -  description
                             -------------------
    begin                : Tue Jul 25 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "texobject.h"

#include "image.h"

TexObject::TexObject()
{
	tex = 0;
	filename = NULL;
}

TexObject::~TexObject()
{
/* 	if(filename != NULL) free(filename); */
}


GLuint TexObject::load_texture(char *fname)
{
//	printf("loading texture %s\n", fname);
	IMAGE *image = ImageLoad(fname);
	glGenTextures(1, &tex);

	glBindTexture(GL_TEXTURE_2D, tex);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

	glTexImage2D(GL_TEXTURE_2D, 0, 3, image->sizeX, image->sizeY, 0,
		GL_RGB, GL_UNSIGNED_BYTE, image->data);

	filename = (char *)malloc( strlen(fname) );
	strcpy(filename, fname);

	return tex;
}

GLuint TexObject::get_texture()
{
	return tex;
}

void TexObject::free_tex()
{

}

/** checks if the texobject's filename matches
fname
 */
int TexObject::matches( char *fname )
{
	return !strcmp(fname, filename);
}
