/***************************************************************************
                          userview.cpp  -  description
                             -------------------
    begin                : Fri Jun 16 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string>

#include "userview.h"
#include "image.h"


UserView::UserView(int a, int b, int c, int d) : puObject(a, b, c, d)
{

}

void UserView::load_images(char *fname, vector<GLuint> *texlist)
{
	/* this function loads a list of images from a text file
	and binds them to a textures.  Note that it then _adds_ it to
	the vector specified and does not clear the vector */

	FILE *file;
	char * image_name;
	image_name = (char *)malloc(64);
	GLuint texture;
    if(!(file = fopen(fname, "r")))
	{
		printf("Can't open file for loading images: %s\n", fname);
		assert(0);	/* exit and tells user what line */
	}

	while(fscanf(file, "%s", image_name) != EOF)
	{
		texture = TexList::load_texture( image_name );
		texlist->push_back(texture);		
	}

/*	free(image_name);*/
}

void UserView::hide()
{
	int i;
	for(i = 0;i < CARGO_NUM;i++)
	{
		cargo[i]->hide();
	}
	visible = 0;
}

void UserView::reveal()
{
	int i;
	for(i = 0;i < CARGO_NUM;i++)
	{
		cargo[i]->reveal();
	}
	visible = 1;
}

void UserView::getCargoLoc(float *x, float *y, int i)
{
/* gets passed pointers to 2 float vars
   and returns the position of the 'i'th cargo unit */
	*x = (18+(93* (i % 2)))*size_mult;
	*y = (356-(160+(6*(i-(i%2)))))*size_mult;
}


void UserView::makeCargoLabels(Platform *p, int *offset)
{
	if (p==NULL) return;
	for(int i=0;i<CARGO_NUM;i++)
	{
        char *s = (char *)malloc(32);
		memset(s, 0, 32);

		if (offset == NULL)
			sprintf(s, "%d", p->getCargo(i));
		else
			sprintf(s, "%d", p->getCargo(i) + offset[i]);
		cargo[i]->setLabel(s);
	}
}

UserView::~UserView(){
}
