/***************************************************************************
                          userview.h  -  description
                             -------------------
    begin                : Fri Jun 16 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef USERVIEW_H
#define USERVIEW_H

#include <vector>
#include <GL/gl.h>

#include <plib/pu.h>
#include <sigc++/signal_system.h>

#include "unit_def.h"

#include <platform.h>

#include "texlist.h"

using namespace std;
using namespace SigC;

/**
  *@author Blake Friesen
  */

class UserView : public puObject, public Object{
public:
	UserView(int a, int b, int c, int d);
	~UserView();
	void hide();
	void reveal();
protected:
	void getCargoLoc(float *x, float *y, int i);
	void load_images(char *fname, vector<GLuint> *tex);
	/* loads the images listed in fname as textures _appended_ onto tex */

	void makeCargoLabels(Platform *p, int *offset);

	puText		*cargo[CARGO_NUM];
};

#endif
