/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sat Jan  1 20:11:37 CST 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream.h>
#include <stdlib.h>

#include "gl/foundationgl.h"

float size_mult = 0.0;
int gl_width, gl_height = 0;

FoundationGL *cgl;
puButton    *hide_menu_button ;
puText		*planet_name;
//float size_mult;
//int gl_width, gl_height;

static void specialfn ( int key, int, int )
{
  puKeyboard ( key + PU_KEY_GLUT_SPECIAL_OFFSET, PU_DOWN ) ;
  glutPostRedisplay () ;
}

static void keyfn ( unsigned char key, int, int )
{
  puKeyboard ( key, PU_DOWN ) ;
  glutPostRedisplay () ;
}

static void motionfn ( int x, int y )
{
  puMouse ( x, y ) ;
  glutPostRedisplay () ;
}

static void mousefn ( int button, int updown, int x, int y )
{
  puMouse ( button, updown, x, y ) ;
  glutPostRedisplay () ;
}


static void display()
{
	cgl->display();
}

void *start(void *)
{
	cgl->start();
	return 0;
}

void *cgl_game_loop(void *)
{
	cgl->game_loop();
	return 0;
}


int main(int argc, char *argv[])
{	
	if(argc > 1) size_mult = atof(argv[1]);
		else size_mult = 1.0;
	gl_width = (int)(640 * size_mult);
	gl_height = (int)(480 * size_mult);
	glutInitWindowSize    ( gl_width, gl_height ) ;
	glutInit              ( &argc, argv ) ;
	glutInitDisplayMode   ( GLUT_RGB | GLUT_DOUBLE ) ;
	glutCreateWindow      ( "FoundationGL"  ) ;
	glutKeyboardFunc      ( keyfn     ) ;
	glutSpecialFunc       ( specialfn ) ;
	glutMouseFunc         ( mousefn   ) ;
	glutMotionFunc        ( motionfn  ) ;
	glutPassiveMotionFunc ( motionfn  ) ;
	
	
	puInit();
	#ifdef VOODOO
	puShowCursor () ;
	#endif
	glutDisplayFunc       ( display ) ;

	fntTexFont *hel = new fntTexFont ;
	fntTexFont *tim = new fntTexFont ;
	hel -> load ( "helvetica_bold.txf" ) ;
	tim -> load ( "times_bold.txf" ) ;
	puFont helvetica ( hel, 12*size_mult ) ;
	puFont times_medium ( tim, 14*size_mult ) ;
	puSetDefaultFonts        ( helvetica, helvetica ) ;
	puSetDefaultStyle        ( PUSTYLE_SMALL_SHADED ) ;
//	puSetDefaultColourScheme ( 0.1, 0.4, 0.1, 1.0) ;
	puSetDefaultColourScheme ( 0.35, 0.4, 0.51, 1.0) ;

	cgl = new FoundationGL(argc, argv);
//	new PlanetView(500, (int)(gl_height/2), WIDTH, gl_height);
//	glMatrixMode(GL_MODELVIEW);
//	glMatrixMode(GL_PROJECTION); glLoadIdentity();
//    glViewport(0, 0, WIDTH, gl_height);

//	puGroup *pug = new puGroup(0,0);
/*
	hide_menu_button = new puButton     ( 0, 0, 150, 50 ) ;
	hide_menu_button->setValue          (    TRUE      ) ;
	hide_menu_button->setLegend         ( "i"  ) ;
	hide_menu_button->setCallback       ( hide_menu_cb ) ;
	hide_menu_button->makeReturnDefault (    TRUE      ) ;
*/
//	puInput *input_box = new puInput(0,0, 400, 40);
//    planet_name = new puText(10,40);
//	planet_name->setLabel("Planet Name");
//    pug->close();
/*
	puBox *abox = hide_menu_button->getABox();
	puBox *bbox = hide_menu_button->getBBox();
	printf("button abox: %d, %d, %d, %d\n", abox->min[0], abox->min[1], abox->max[0], abox->max[1]);
	printf("button bbox: %d, %d, %d, %d\n", bbox->min[0], bbox->min[1], bbox->max[0], bbox->max[1]);
*/
	pthread_t thread1, thread2;
	pthread_create( &thread1, NULL, start, NULL);
	pthread_create( &thread2, NULL, cgl_game_loop, NULL);
    glutMainLoop () ;  cout << "Hello, World!" << endl;

  return EXIT_SUCCESS;
}
