/***************************************************************************
                          platform.h  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef PLATFORM_H
#define PLATFORM_H

#include <stdio.h>
#include <vector>
#include "unit_def.h"
#include <point.h>
#include <queue>
#include <string>

#define DENSITY_SIZE 50
#define NAME_SIZE 32

class Platform{
public:
	Platform();
	virtual ~Platform();
	int getCargo(int t); /* gets amount of cargo of type t */
    void setCargo(int n, int t); /* sets cargo of type t to n */
/*
	void setTri(int n);
	void setDeu(int n);
	void setPop(int n);
*/
	int getId();
	void setId(int);
	int loadCargo(int n, int t); /* gives n of type t cargo */
	int unloadCargo(int n, int t);
	Point getPos();
	void setName(string);
	string getName();
	void getCargo(char data[CARGO_NUM][32]);

	virtual bool isFleet();
	virtual bool checkOwner(int c);
	virtual int cargoFree();
	virtual int cargoMax();
  /** sets data for object */
	virtual int setRaw(char *buf);
  /* gets raw data of an object */
	virtual int getRaw(char *buf);
	Point pos;
	int owner;
	int id; /* unique identifier */
	char nameid[NAME_SIZE];
//protected:
	int cargo[CARGO_NUM];	//called cargo to be consistent w/ ships
};


#endif
