/***************************************************************************
                          foundationserver.h  -  description
                             -------------------
    begin                : Mon Jan 31 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFLICTSERVER_H
#define CONFLICTSERVER_H

#include <stdio.h>
#include <stdlib.h>

#include <netengine.h>
#include <player.h>

#include <network.h>

#include <foundationcore.h>


/**
  *@author Blake Friesen
  */

class FoundationServer : public FoundationCore {
public: 
	FoundationServer();
	~FoundationServer();
    	void game_loop();
	void wait_for_start();
  /**  */

private:
	int num_players;
    void setBuildItem(int p, int g, int t);
	void handle_game_join(sockaddr_in addr, char *buf, int len);
	void handle_chat_msg(char *buf, int len);
	int find_player(struct sockaddr_in);
		  /** finds a player by their Inet address
			searchs by IP and port
			returns -1 on unknown addr */

	int start_game();
	void handle_game_start(sockaddr_in sock, char *buf, int len);
	void handle_planet_info(char *buf, int len);
	void handle_prod_request(sockaddr_in addr, char *buf, int len);
	void handle_planet_part(sockaddr_in, char *buf, int len);
	void handle_add_waypoint(sockaddr_in addr, char *buf, int len);
	void handle_transfer_cargo(sockaddr_in addr, char *buf, int len);
	void send_player_info();
	void 			moveFleet();
  /** sends player names to everyone on
game start along with their starting location
and playerid */

	int init_planet(int player_id);
  /** seeds planets with players when 
game starts */

	int player_num; /* number of players */
};

#endif
