#include <shipInfo.h>
#include <fstream.h>
#include <unit_def.h>
#include <string>

ShipInfo::ShipInfo(){
	loadShipSpecs();
}

void ShipInfo::loadShipSpecs()
{
/* needs to be replaced by a proper lex parser */
	Ship s;
	int id, cargo, pass, guns, canons, tor, speed = 0;
	ifstream input("shipspecs.txt");
	for(int x=0;x<T_NUM;x++)
	{
		input >> id;
		input >> cargo;
		input >> guns;
		input >> canons;
		input >> tor;
		input >> speed;
		s.set(guns, canons, tor, pass, cargo);
		s.setType(x);
		shiptype_list.push_back(s);
	}
}

int ShipInfo::loadFleet(int f, int n, int t)
{
	return fleet[f]->loadCargo(n, t);
}

void ShipInfo::moveFleet()
{
	printf("moving all fleets...\n");
	for(int x=0;x<(int)fleet.size();x++)
		fleet[x]->move();
}

Fleet *ShipInfo::getFleet(int f)
{
	for(int i = 0;i<fleet.size();i++)
		if ((int)fleet[i]->getId()==f) return fleet[i];
	cerr << "FleetID reference out of range: " << fleet.size() << endl;
	return NULL;
}

void ShipInfo::addShip(int s, Point p, int owner)
{
	Ship newship;
	newship = shiptype_list[s];
	cout << "adding ship type " << newship.getCargoMax() << endl;

/* 	check if there is an existing fleet at this position
	If there is, add it to a fleet */
	vector<Fleet *> fleet_here = getFleet( p );
	if( fleet_here.size() != 0) fleet_here[0]->addShip( newship );

/* otherwise, make a new fleet */
	Fleet *f = new Fleet(p);
	f->addShip(newship);
	f->owner = owner;
	fleet.push_back(f);
}

vector<Fleet *> *ShipInfo::getFleet()
{
	return &fleet;
}

vector<Fleet *> ShipInfo::getFleet(Point p)
{
	vector<Fleet *> a;
	for(int x=0;x<(int)fleet.size();x++)
		if(fleet[x]->getPos()==p) a.push_back(fleet[x]);
	return a;
}

vector<Fleet *> ShipInfo::getFleetOwner(int owner)
{
	vector<Fleet *> a;
	for(int x=0;x<(int)fleet.size();x++)
		if(fleet[x]->getId()==owner) a.push_back(fleet[x]);
	return a;
}

int ShipInfo::xfer(Platform *src, Platform *dest, int amount, int cargo_type)
{
	/*	Transfers up to N units, limited by free cargo space
		Then unloads the amount that was succesfully loaded */
	int cargo_amount, loaded;
	cargo_amount = src->loadCargo( -amount, cargo_type);
	loaded = dest->loadCargo(cargo_amount, cargo_type);
	if( (cargo_amount - loaded) > 0 )
		src->loadCargo(cargo_amount - loaded,cargo_type);
	return cargo_amount;
}

void ShipInfo::addFleet(Fleet *f)
{
	/* 	first, check if there is already a fleet with the same id
		it might for a network update */

	if( getFleet( f->getId() ) != NULL) return;
	/* if not, we'll just add it to the end */
	fleet.push_back(f);
	printf("new fleet size: %d\n", fleet.size() );
}

int ShipInfo::setDest(int f, Point p)
{
	getFleet(f)->setDest(p);
}
