#ifndef SHIPINFO_H
#define SHIPINFO_H

#include "shipDesign.h"
#include "unit_def.h"
#include <vector>
#include <ship.h>
#include <prodItem.h>
#include <fleet.h>

#include <sigc++/signal_system.h>

using namespace std;
using namespace SigC;

class ShipInfo : public Object{
public:
	ShipInfo();
	void 			addShip(int s, Point p, int owner);
	int 			setDest(int f, Point dest);
	int 			xfer(Platform *a, Platform *b, int amount, int cargo);	
	int 			loadFleet(int f, int n, int t);
	void 			moveFleet();
	Fleet *			getFleet(int f);
	vector<Fleet *> getFleet(Point p);
	vector<Fleet *> *getFleet();
	vector<Fleet *> getFleetOwner(int owner);
	void addFleet(Fleet *f);

private:
	void loadShipSpecs();
	vector<Ship> shiptype_list;
	vector<Fleet *> fleet;
};


#endif
