/***************************************************************************
                          system.h  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef SOLARSYSTEM_H
#define SOLARSYSTEM_H

#include <vector>
#include <unit_def.h>
#include <prodItem.h>
#include <point.h>
#include <queue>
#include <platform.h>
#include <shipInfo.h>

#define DENSITY_SIZE 50

using namespace std;
//using namespace SigC;


class SolarSystem : public Platform{
public:
	SolarSystem();
	vector <int> getneeds();
	void grow();
	int produce();
	int setBuildItem(int g, int t);
	int setBuildItem(int g, int t, int id); /* sets build item with an id */
	int getFrontId();	/* 	returns the id of the item that is at
						 	the front of the queue */
	int setFrontId(int id);/* 	set the id of the item that should be at
						 	the front of the queue but might not be there. */
	bool isBuilding(int g, int t);
	bool canBuild(int g, int t);
	static ShipInfo *shipdata;
	bool isFleet();
	int getOwner();
	bool checkOwner(int c);
	queue<ProdItem> getProdQueue(); /* 	returns a _copy_ of the
										production queue */

	static ProdItem b_template[G_NUM][T_NUM];
	static void loadcosts();
	int getRaw(char *buf);
	int setRaw(char *buf);
  /** returns the percentage complete of the top
production item */
  float getProgress();
  /** synchronizes building progress of the
first item on a planet */
  void setProgress(float progress);
	bool building[BUILDING_NUM];

private:
	vector<int> make_density();
	
	static int unique_id; /* unique ID for production items */
	queue<ProdItem> prod_q;
//	ProdItem currentItem;
	int popmax; // no actual limit to pop max, just limit to cheap growth
	float tri_density[DENSITY_SIZE];
	float deu_density[DENSITY_SIZE];
	float x_range[DENSITY_SIZE];

};


#endif
